package java.beans.beancontext;

import java.net.URL;
import java.io.InputStream;
import java.io.IOException;
import java.beans.Visibility;
import java.beans.DesignMode;
import java.util.Collection;

public interface BeanContext extends BeanContextChild, Collection, DesignMode, Visibility
{
    public static final Object globalHierarchyLock = new Object();
    
    public abstract Object instantiateChild(String p0) throws IOException, ClassNotFoundException;
    
    public abstract InputStream getResourceAsStream(String p0, BeanContextChild p1) throws IllegalArgumentException;
    
    public abstract URL getResource(String p0, BeanContextChild p1) throws IllegalArgumentException;
    
    public abstract void addBeanContextMembershipListener(BeanContextMembershipListener p0);
    
    public abstract void removeBeanContextMembershipListener(BeanContextMembershipListener p0);
}
